#Задача K. Отходы производства
 12-13 стр#
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    double r;
    cin >> r;

    vector<double> waste(n + 1, 0.0);

    for (int i = 1; i <= n; i++) {
        int d, w;
        cin >> d >> w;
        waste[d] = (1 - r) * waste[d - 1] + r * w;
    }

    vector<double> results;

    for (int i = 0; i < m; i++) {
        int q;
        cin >> q;
        results.push_back(waste[q]);
    }

    for (double result : results) {
        cout << result << endl;
    }

    return 0;
}
